田草博客
日志搜索


 标题   内容 评论


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件
-电信用户-|-网通用户-
-博客论坛-|-软件下载-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2018 - 11 48
    123
45678910
11121314151617
18192021222324
252627282930


站点统计

最新评论



Excel打印时候设置打印区域 2017一级注册结构工程师真题空白卷
未知 获取被剪裁块的剪裁编辑   [ 日期:2018-09-06 ]   [ 来自:本站原创 ]  HTML


http://spiderinnet1.typepad.com/blog/2012/10/autocad-net-retri ... oundary-for-insertblockreference.html

Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.DatabaseServices.Filters
Imports Autodesk.AutoCAD.Geometry

Public Class XClipRetriever
    <CommandMethod("RXC", CommandFlags.Modal Or CommandFlags.UsePickSet)> _
    Public Shared Sub RetrieveXClipBoundary_Method()
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
        Try
            If ed.SelectImplied().Status <> PromptStatus.OK Then
                Throw New System.Exception("Nothing has been pre-selected!")
            End If

            Dim BlockReferenceRXClass As RXClass = RXClass.GetClass(GetType(BlockReference))
            Using tr As Transaction = Application.DocumentManager.MdiActiveDocument.TransactionManager.StartTransaction()
                For Each id As ObjectId In ed.SelectImplied().Value.GetObjectIds()
                    If id.ObjectClass = BlockReferenceRXClass Then
                        Dim blkRef As BlockReference = CType(tr.GetObject(id, OpenMode.ForRead), BlockReference)
                        If blkRef.ExtensionDictionary <> ObjectId.Null Then
                            Dim extdict As DBDictionary = CType(tr.GetObject(blkRef.ExtensionDictionary, OpenMode.ForRead), DBDictionary)
                            If extdict.Contains("ACAD_FILTER") Then
                                Dim dict As DBDictionary = CType(tr.GetObject(extdict.GetAt("ACAD_FILTER"), OpenMode.ForRead), DBDictionary)
                                If dict.Contains("SPATIAL") Then
                                    Dim filter As SpatialFilter = CType(tr.GetObject(dict.GetAt("SPATIAL"), OpenMode.ForRead), SpatialFilter)
                                    DrawPolygon(blkRef.Database, filter.Definition.Normal, filter.ClipSpaceToWorldCoordinateSystemTransform, filter.Definition.GetPoints())
                                End If
                            End If
                        End If
                    End If
                Next

                tr.Commit()
            End Using
        Catch ex As System.Exception
            ed.WriteMessage(Environment.NewLine + ex.Message)
        End Try
    End Sub

    Public Shared Function DrawPolygon(ByVal db As Database, ByVal normal As Vector3d, ByVal mat As Matrix3d, ByVal vertices As Point2dCollection) As ObjectId
        Dim ret As ObjectId = ObjectId.Null

        Dim tr As Transaction = db.TransactionManager.TopTransaction
        Dim btr As BlockTableRecord = CType(tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite), BlockTableRecord)
        Using pl As New Polyline()
            pl.SetDatabaseDefaults()
            pl.ColorIndex = 3
            pl.Closed = True
            Dim i As Integer = 0
            While i < vertices.Count
                pl.AddVertexAt(0, vertices(i), 0, 0, 0)
                System.Math.Max(System.Threading.Interlocked.Increment(i), i - 1)
            End While
            pl.TransformBy(mat)
            btr.AppendEntity(pl)
            tr.AddNewlyCreatedDBObject(pl, True)
            ret = pl.ObjectId
        End Using

        Return ret
    End Function
End Class



[本日志由 tiancao1001 于 2018-09-06 03:53 PM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:2*9=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
版权所有:田草博客
tiancao1001&126.com网友交流QQ群:11740834
Powered by L-Blog V1.08 (SE) Final© 2007-2009